import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.datatransfer.Clipboard;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.StringSelection;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.KeyEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.io.File;
import java.text.DecimalFormat;
import java.text.ParseException;
import java.util.ArrayList;
import java.util.StringTokenizer;

import javax.sound.sampled.AudioFormat;
import javax.sound.sampled.AudioInputStream;
import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.Clip;
import javax.sound.sampled.DataLine;
import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComponent;
import javax.swing.JFormattedTextField;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JTable;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.KeyStroke;
import javax.swing.WindowConstants;
import javax.swing.border.BevelBorder;
import javax.swing.border.EtchedBorder;
import javax.swing.border.LineBorder;
import javax.swing.border.TitledBorder;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableColumn;
import javax.swing.text.MaskFormatter;

import ij.IJ;
import ij.ImagePlus;
import ij.WindowManager;
import ij.gui.OvalRoi;
import ij.gui.PolygonRoi;
import ij.gui.Roi;
import ij.gui.Wand;
import ij.measure.ResultsTable;
import ij.plugin.frame.PlugInFrame;
import ij.plugin.frame.RoiManager;
import ij.process.ImageProcessor;

public class AATAP_ extends PlugInFrame {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private ImagePlus imp, imp_temp;
	private RoiManager rm;
	Roi []roiArray_vat;
	ResultsTable rt;
	private JFrame snakeMsg;
	
	DecimalFormat df_1 = new DecimalFormat("0.0");
	DecimalFormat df_3 = new DecimalFormat("0.000");
	private int snakeColor_RED = 0;
//	private int snakeColor_GREEN = 1;
//	private int snakeColor_BLUE = 2;
	private int thresholdAverage = 0;
	private double thresholdMin = 0, thresholdMax = 0;
	private boolean showMore = false;
	private String msg_help = "Kurzbeschreibung:\n" +
			"   ..\n" +
			"Nur in Kombination mit dem Plugin 'ABSnake_' verwendbar!\n" +
			"  \n" +
			"[Aktivieren]            -   darstellen von Kontrast + Ellipse\n" +
			"[Reset]                  -   Ursprungswerte wiederherstellen, loescht Tabellen\n" +
			"[Segmentieren]   -   startet das Plugin -ABSnake-\n" +
			"[Finde ROI]          -   setzt die ROI jedes einzelnen Slices,\n" +
			"                                  gruene Markierung bezieht sich dabei immer\n" +
			"                                  auf vorhergehende Schicht\n" +
			"[<<],[>>]                -   Durchblaettern + ROI-Darstellung je Slice\n" +
			"                                  (fuer Kontrolle)\n" +
			"[Berechnen!]       -   analysiert alle Flaechen innerhalb der ROI je Schicht\n" +
			"";
	
	OvalRoi oval;
	int oval_x = 118;
	int oval_y = 183;
	int oval_width = 311;
	int oval_height = 223;
	private JButton but_findROI, but_calculate, but_back, but_forward;
	private JCheckBox cb_snake, cb_threshold, cb_logShow;
	private JTextField tf_result_compl, tf_result_visc, tf_result, tf_tat_mass,
		tf_vat_mass, tf_scat_mass;
	private JFormattedTextField tf_thickness, tf_particleMin, tf_particleMax;
	private JLabel l_quotValue;
	private JFrame legend;
	private JTabbedPane tab;
	private ArrayList<Float> list_vat = new ArrayList<Float>(), list_tat = new ArrayList<Float>(); 
	private JTable resultTable_vat, resultTable_tat, resultTable_scat;
	private DefaultTableModel tModel_vat, tModel_tat, tModel_scat;
	private String[] vat = new String[3], tat = new String[3], scat = new String[3];
	private ArrayList<Integer> thresholdStack;
	
	public AATAP_() {
		super("AATAP");
		makeGUI();
		
		legend = new MessageFrame();
	}

	private void makeGUI() {
		final JPanel contentPane = new JPanel();
		contentPane.setLayout(new BorderLayout());
		
		JPanel panel_north = new JPanel();
		panel_north.setBorder(new EtchedBorder());
		panel_north.setLayout(new BoxLayout(panel_north, BoxLayout.X_AXIS));
		
		JPanel rButtons	= new JPanel();
		ButtonGroup bg = new ButtonGroup();
		final JRadioButton rbut_visceral = new JRadioButton("Visceral");
		rbut_visceral.setSelected(true);
		final JRadioButton rbut_complete = new JRadioButton("Total");
		rbut_complete.setEnabled(false);
		bg.add(rbut_visceral); bg.add(rbut_complete); 
		rButtons.add(rbut_visceral);
		rButtons.add(rbut_complete);
		panel_north.add(rButtons);
		
		JPanel startPanel = new JPanel();
		JButton but_activate = new JButton("ACTIVATE");
		but_activate.setAlignmentX(Component.CENTER_ALIGNMENT);
		but_activate.setActionCommand(but_activate.getName());
		startPanel.add(but_activate);
		panel_north.add(startPanel);
		
		JButton but_reset = new JButton("Reset");
		but_reset.setEnabled(true);
		panel_north.add(but_reset);
		contentPane.add(panel_north, BorderLayout.NORTH);
		
		JPanel panel_left = new JPanel();
		panel_left.setLayout(new BoxLayout(panel_left, BoxLayout.Y_AXIS));
		contentPane.add(panel_left, BorderLayout.CENTER);
		
		JPanel panel_right = new JPanel();
		panel_right.setLayout(new BorderLayout());
		
		JPanel panel_erg = new JPanel();
		panel_erg.setBorder(new TitledBorder(new EtchedBorder(BevelBorder.RAISED), 
				" Results ", TitledBorder.CENTER, TitledBorder.DEFAULT_POSITION));
		tab = new JTabbedPane(JTabbedPane.BOTTOM);
		fillPanel_Complete(panel_erg);
		tab.add("          overall results          ", panel_erg);
		tab.add("VAT", fillPanel_VAT());
		tab.add("TAT", fillPanel_TAT());
		tab.add("SCAT", fillPanel_SCAT());
		contentPane.add(tab, BorderLayout.EAST);
		
		JPanel checkP = new JPanel();
		cb_snake = new JCheckBox("Snake");
		cb_snake.setEnabled(false);
		final JButton but_snake = new JButton("Segmentation");
		but_snake.setEnabled(false);
		checkP.add(cb_snake);
		checkP.add(but_snake);
		panel_left.add(checkP);
		
		but_findROI = new JButton("Find ROI");
		but_findROI.setEnabled(false);
		JPanel slicePanel = new JPanel();
		slicePanel.add(but_findROI);
		panel_left.add(slicePanel);
		
		but_findROI.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent e) {
				actionOfFindROI();
			}
		});
		
		JPanel p_backNext = new JPanel();
		but_back = new JButton("<<");
		but_back.setEnabled(false);
		but_back.setActionCommand("back");
		but_forward = new JButton(">>");
		but_forward.setEnabled(false);
		but_forward.setActionCommand("forward");
		but_forward.addActionListener(new SliceMover(1));
		but_back.addActionListener(new SliceMover(-1));
		p_backNext.add(but_back);
		p_backNext.add(but_forward);
		panel_left.add(p_backNext);
		
		JPanel sliceThick = new JPanel();
		JLabel l_thickness = new JLabel("Slice Thickness [mm]:");
		try {
			tf_thickness = new JFormattedTextField(
					new MaskFormatter("##.#"));
		} catch (ParseException e1) {
			e1.printStackTrace();
		}
		tf_thickness.setText("01.0");

		tf_thickness.setPreferredSize(new Dimension(30, 20));
		tf_thickness.addFocusListener(new FocusListener() {
			
			@Override
			public void focusLost(FocusEvent e) {
				if(tf_thickness.getText().replaceAll(" ", "").equals("0") 
						|| tf_thickness.getText().equals("  ")){
					tf_thickness.setText("01.0");
				}
				float thick = Float.parseFloat(tf_thickness.getText());
				if(thick < 10)
					tf_thickness.setText("0"+thick);
			}
			
			@Override
			public void focusGained(FocusEvent e) {
				tf_thickness.selectAll();
			}
		});
		sliceThick.add(l_thickness);
		sliceThick.add(tf_thickness);
	
		
		JPanel calculatePanel = new JPanel();
		calculatePanel.setLayout(new BoxLayout(calculatePanel, BoxLayout.Y_AXIS));
		JPanel particlePanel = new JPanel();
		calculatePanel.setBorder(new EtchedBorder());
		calculatePanel.setEnabled(false);
		JLabel l_particleSize = new JLabel("Size [qmm]:");
		try {
			tf_particleMin = new JFormattedTextField(new MaskFormatter("###"));
		} catch (ParseException e1) {
			e1.printStackTrace();
		}
		tf_particleMin.setText("9");
		tf_particleMin.setPreferredSize(new Dimension(30, 20));
		tf_particleMin.setFocusLostBehavior(JFormattedTextField.PERSIST);
		tf_particleMax = new JFormattedTextField();
		tf_particleMax.setText("Infinity");
		tf_particleMin.addFocusListener(new FocusListener() {
			
			@Override
			public void focusLost(FocusEvent e) {
				if(tf_particleMin.getText().replaceAll(" ", "").equals("0") 
						|| tf_particleMin.getText().equals("   ")){
					tf_particleMin.setText("9");
				}
				tf_particleMin.getText().replaceAll(",", ".");
			}
			
			@Override
			public void focusGained(FocusEvent e) {
				tf_particleMin.selectAll();
			}
		});
		tf_particleMax.addFocusListener(new FocusListener() {
			
			@Override
			public void focusLost(FocusEvent e) {
				if(tf_particleMax.getText().replaceAll(" ", "").equals("0") 
						|| tf_particleMax.getText().equals("   ")){
					tf_particleMax.setText("Infinity");
				}
				tf_particleMax.getText().replaceAll(",", ".");
			}
			
			@Override
			public void focusGained(FocusEvent e) {
				tf_particleMax.selectAll();
			}
		});
		particlePanel.add(l_particleSize);
		particlePanel.add(tf_particleMin);
		particlePanel.add(tf_particleMax);
		
		//TODO Threshold aktivieren
		JPanel threshold = new JPanel();
		cb_threshold = new JCheckBox("use mean of threshold");
//		cb_threshold.setEnabled(false);
		
		threshold.add(cb_threshold);
		
		
		but_calculate = new JButton("Calculate!");
		but_calculate.setEnabled(false);
		but_calculate.setAlignmentX(Component.CENTER_ALIGNMENT);
		
		calculatePanel.add(sliceThick);
		calculatePanel.add(particlePanel);
		calculatePanel.add(threshold);	
		calculatePanel.add(but_calculate);
		calculatePanel.add(new JLabel(" "));
		panel_left.add(calculatePanel);
		
		JPanel info = new JPanel();
		cb_logShow = new JCheckBox();
		cb_logShow.setToolTipText("show more results in Log");
		JButton but_help = new JButton("HELP"); 
		but_help.setBorderPainted(false);
		but_help.setContentAreaFilled(false);
		but_help.addMouseListener(new MouseAdapter() {
		
			public void mouseEntered(MouseEvent e) {
				legend.setBounds(e.getXOnScreen()+250, e.getYOnScreen()-150, 417, 305);
				legend.setVisible(true);
			}
			public void mouseExited(MouseEvent e) {
				legend.dispose();
				repaint();
			}
		});
		JButton but_snakeMsg = new JButton("Snake-Values");
		info.add(cb_logShow);
		info.add(but_help);
		info.add(but_snakeMsg);
		info.setBorder(new BevelBorder(BevelBorder.LOWERED));
		panel_left.add(info);
		
		cb_logShow.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent e) {
				if(cb_logShow.isSelected())
					showMore = true;
				else
					showMore = false;
			}
		});
		rbut_complete.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent e) {
				resetButtons(but_snake);
			}
		});
		rbut_visceral.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent e) {
				resetButtons(but_snake);
			}
		});
		but_snakeMsg.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				showSnakePar(200,200);
			}
		});
		but_activate.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent e) {
				activate(rbut_visceral);
			}

		});
		but_reset.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent e) {
				reset();
			}
		});
		cb_snake.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent e) {
				if(cb_snake.isSelected()){
					but_snake.setEnabled(true);
					showSnakePar(50,300);
					
					if(rbut_visceral.isSelected()){
						oval = new OvalRoi(oval_x, oval_y, oval_width, oval_height);
						imp.setRoi(oval);
						for (int i = 0; i < roiArray_vat.length; i++) {
							roiArray_vat[i] = imp.getRoi();
						}
//						IJ.log("Oval: x-"+oval.getBounds().x+", y-"+oval.getBounds().y+", h-"+oval.getBounds().height+", w-"+oval.getBounds().width);
					}else{
						imp.killRoi();
						oval = new OvalRoi(oval_x-50, oval_y-35, oval_width+105, oval_height+100);
						imp.setRoi(oval);
						for (int i = 0; i < roiArray_vat.length; i++) {
							roiArray_vat[i] = imp.getRoi();
						}
					}
				}
				else{
					but_snake.setEnabled(false);
					but_findROI.setEnabled(false);
				}
			}
		});
		but_snake.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent e) {
				runSnake();
				cb_snake.setEnabled(false);
				but_snake.setEnabled(false);
			}
		});
		cb_threshold.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				if(cb_threshold.isSelected()){
					average(thresholdStack);
				}
			}

		});
		but_calculate.addActionListener(new ActionListener() {
			private boolean isVisceral = false, isComplete = false;

			@Override
			public void actionPerformed(ActionEvent e) {
				actionOfCalculate(rbut_visceral, rbut_complete);
			}

			/**
			 * @param rbut_visceral
			 * @param rbut_complete
			 */
			private void actionOfCalculate(final JRadioButton rbut_visceral,
					final JRadioButton rbut_complete) {
				rt.reset();
				
				int flag = 1;
				int j = IJ.setupDialog(imp, flag);
				setWaitCursor();
				
				convert2Mask();
				if(cb_threshold.isSelected()){
					thresholdMin = thresholdAverage;
				}
				imp.getProcessor().setThreshold(thresholdMin, thresholdMax, ImageProcessor.BLACK_AND_WHITE_LUT);
				
				if(rbut_visceral.isSelected()){
						
//					makeBinary();
					setSavedROI();
					
					if(imp.getRoi().isVisible()){
						
						setSavedROI(); 
						if (j == flag) {	// No
							IJ.run(imp,"Analyze Particles...", "size="
													+ tf_particleMin.getText()
													+ "-"
													+ tf_particleMax.getText()
													+ " circularity=0.00-1.00 show=Masks display summarize slice");
						} else {	// Yes
							calcResults(vat, list_vat, tModel_vat, tf_result_visc, tf_vat_mass);
							isVisceral = true;
							rbut_complete.setEnabled(true);
							but_findROI.setEnabled(false);

							fillResults();
						}
					}
					
				}else if(rbut_complete.isSelected()){
					if(j == flag){
						IJ.run(imp, "Analyze Particles...", "size="
								+ tf_particleMin.getText()
								+ "-"
								+ tf_particleMax.getText()
								+ " circularity=0.00-1.00 show=Masks display summarize slice");
					}else{	//Yes

						calcResults(tat, list_tat, tModel_tat, tf_result_compl, tf_tat_mass);
						isComplete = true;
					}
				}
				if(isComplete && isVisceral){
					difference(tf_result_compl, tf_result_visc, tf_result, l_quotValue);
				}
				setDefaultCursor();
			}

			/**
			 * @param rbut
			 */
			private void calcResults(String[] s, ArrayList<Float> list, 
					DefaultTableModel dtm, JTextField field, JTextField fieldMass) {
				imp.setSlice(1);
				setSavedROI(); 
				float sliceArea = 0, sliceArea_temp;
				for (int n = 1; n <= imp.getStackSize(); ) {
					IJ.run(imp, "Analyze Particles...", "size="
							+ tf_particleMin.getText()
							+ "-"
							+ tf_particleMax.getText()
							+ " circularity=0.00-1.00 show=Nothing display slice");
					imp.setSlice(++n);
					setSavedROI(); 
					
					sliceArea_temp = sliceArea;
					sliceArea = calculate(tf_thickness);
					float erg = (sliceArea-sliceArea_temp);
					list.add(erg);
//					IJ.log("..AT "+n+": "+sliceArea+" - "+sliceArea_temp+" = "+erg);
					
					s[0]=String.valueOf(n-1);
					s[1]=String.valueOf(df_1.format(erg));
					s[2]=String.valueOf(calculateMass(erg));
					if(dtm.getRowCount() < imp.getStackSize()){
						dtm.addRow(s);
						
					}
				}
				float calc = summary(list); 
				list.clear();
				field.setText(df_1.format(calc));
				fieldMass.setText(calculateMass(calc));
			}
			
		});
		
		IJ.log("--- Start AATAP-Tool ---");
		
		add(contentPane);
		pack();
		setVisible(true);
	}
	
	private void average(ArrayList<Integer> thresholdStack) {
		int temp = 0;
		for (int i : thresholdStack) {
			temp += i;
		}
		if (temp==0)
			thresholdAverage = 0;
		else
			thresholdAverage = temp/imp.getStackSize();
		IJ.log("mean of treshold: "+thresholdAverage);
	}
	
	private void fillResults() {
		resultTable_vat.updateUI();
	}
	
	/**
	 * 
	 */
	private void showSnakePar(int posX, int posY) {
		if(snakeMsg!=null && snakeMsg.isVisible()){
			
		}else{
			snakeMsg = new Msg4SnakeParameters();
			snakeMsg.setBounds(posX, posY, 255, 260);
			snakeMsg.setVisible(true);
			snakeMsg.setResizable(false);
		}
	}
	
	/**
	 * @param but_snake
	 */
	private void resetButtons(final JButton but_snake) {
		cb_snake.setSelected(false);
		cb_snake.setEnabled(false);
		but_snake.setEnabled(false);
		but_findROI.setEnabled(false);
		but_calculate.setEnabled(false);
		
	}
	
	private void fillPanel_Complete(JPanel panelErg) {
		panelErg.setLayout(new BoxLayout(panelErg, BoxLayout.Y_AXIS));
		JPanel results_compl = new JPanel();
		JLabel l_res_compl = new JLabel("                vol. [ml]     mass [kg]");
		results_compl.add(l_res_compl);
		panelErg.add(results_compl);
		
		JPanel p_tat = new JPanel();
		JLabel l_tat = new JLabel("TAT:   ");
		tf_result_compl = new JTextField("0");
		tf_result_compl.setPreferredSize(new Dimension(55, 25));
		tf_result_compl.setEditable(false);
		tf_tat_mass = new JTextField("0");
		tf_tat_mass.setPreferredSize(new Dimension(55, 25));
		tf_tat_mass.setEditable(false);
		p_tat.add(l_tat);
		p_tat.add(tf_result_compl);
		p_tat.add(tf_tat_mass);
		JPanel p_vat = new JPanel();
		JLabel l_vat = new JLabel("VAT:   ");
		tf_result_visc = new JTextField("0");
		tf_result_visc.setPreferredSize(new Dimension(55, 25));
		tf_result_visc.setEditable(false);
		tf_vat_mass = new JTextField("0");
		tf_vat_mass.setPreferredSize(new Dimension(55, 25));
		tf_vat_mass.setEditable(false);
		p_vat.add(l_vat);
		p_vat.add(tf_result_visc);
		p_vat.add(tf_vat_mass);
		JPanel p_scat = new JPanel();
		JLabel l_scat = new JLabel("SCAT: ");
		tf_result = new JTextField("..");
		tf_result.setPreferredSize(new Dimension(55, 25));
		tf_result.setEditable(false);
		tf_scat_mass = new JTextField("..");
		tf_scat_mass.setPreferredSize(new Dimension(55, 25));
		tf_scat_mass.setEditable(false);
		p_scat.add(l_scat);
		p_scat.add(tf_result);
		p_scat.add(tf_scat_mass);
		
		panelErg.add(p_tat);
		panelErg.add(p_vat);
		panelErg.add(p_scat);
		
		JPanel quotient = new JPanel();
		JLabel l_quotient = new JLabel("  VAT/SCAT => ");
		l_quotValue = new JLabel("     ? : ?     ");
		quotient.add(l_quotient);
		quotient.add(l_quotValue);
		
		panelErg.add(quotient);	
	}
	
	private JPanel fillPanel_VAT(){
		JPanel pVAT = new JPanel();
		pVAT.setLayout(new BoxLayout(pVAT, BoxLayout.Y_AXIS));
		pVAT.setBorder(new TitledBorder(new EtchedBorder(BevelBorder.RAISED), " VAT-Results ", TitledBorder.CENTER, TitledBorder.DEFAULT_POSITION));
		
		String [] head = new String[]{"slice","vol.[ml]","mass [kg]"};
		
		tModel_vat = new DefaultTableModel( head, 0 );

		resultTable_vat = new JTable(tModel_vat);
		new ExportAdapter(resultTable_vat);
		
		TableColumn col = null;
		for(int i=0; i<resultTable_vat.getColumnCount(); i++){
			col = resultTable_vat.getColumnModel().getColumn(i);
			if(i == 0){
				col.setMinWidth(30);
				col.setMaxWidth(40);
			}else if(i == 1){
				col.setMinWidth(55);
				col.setMaxWidth(65);
			}else if(i == 2)
				col.setPreferredWidth(70);
		}
		
		JScrollPane scroll = new JScrollPane( resultTable_vat );
		scroll.setPreferredSize(new Dimension(100, 50));
		
		pVAT.add( scroll  );

		
		return pVAT;
	}
	
	private JPanel fillPanel_TAT(){
		JPanel pTAT = new JPanel();
		pTAT.setLayout(new BoxLayout(pTAT, BoxLayout.Y_AXIS));
		pTAT.setBorder(new TitledBorder(new EtchedBorder(BevelBorder.RAISED), " TAT-Results ", TitledBorder.CENTER, TitledBorder.DEFAULT_POSITION));
		
		String [] head = new String[]{"slice","vol.[ml]","mass [kg]"};
		
		tModel_tat = new DefaultTableModel( head, 0 );

		resultTable_tat = new JTable(tModel_tat);
		new ExportAdapter(resultTable_tat);
		
		TableColumn col = null;
		for(int i=0; i<resultTable_tat.getColumnCount(); i++){
			col = resultTable_tat.getColumnModel().getColumn(i);
			if(i == 0){
				col.setMinWidth(30);
				col.setMaxWidth(40);
			}else if(i == 1){
				col.setMinWidth(55);
				col.setMaxWidth(65);
			}else if(i == 2)
				col.setPreferredWidth(70);
		}
		
		JScrollPane scroll = new JScrollPane( resultTable_tat );
		scroll.setPreferredSize(new Dimension(100, 50));
		
		pTAT.add( scroll  );

		
		return pTAT;
	}
	
	private JPanel fillPanel_SCAT(){
		JPanel pSCAT = new JPanel();
		pSCAT.setLayout(new BoxLayout(pSCAT, BoxLayout.Y_AXIS));
		pSCAT.setBorder(new TitledBorder(new EtchedBorder(BevelBorder.RAISED), " SCAT-Results ", TitledBorder.CENTER, TitledBorder.DEFAULT_POSITION));
		
		String [] head = new String[]{"slice","vol.[ml]","mass [kg]"};
		
		tModel_scat = new DefaultTableModel( head, 0 );

		resultTable_scat = new JTable(tModel_scat);
//		resultTable_scat.setEnabled(false);
		new ExportAdapter(resultTable_scat);
		
		TableColumn col = null;
		for(int i=0; i<resultTable_scat.getColumnCount(); i++){
			col = resultTable_scat.getColumnModel().getColumn(i);
			if(i == 0){
				col.setMinWidth(30);
				col.setMaxWidth(40);
			}else if(i == 1){
				col.setMinWidth(55);
				col.setMaxWidth(65);
			}else if(i == 2)
				col.setPreferredWidth(70);
		}
		
		JScrollPane scroll = new JScrollPane( resultTable_scat );
		scroll.setPreferredSize(new Dimension(100, 50));
		
		pSCAT.add( scroll  );

		
		return pSCAT;
	}

	/**
	 * 
	 */
	private void convert2Mask() {
		IJ.run(imp, "Convert to Mask", "  black");
	}
	
	/**
	 * 
	 */
	@SuppressWarnings("static-access")
	private void setSavedROI() {
		imp.killRoi();
		imp.setRoi(roiArray_vat[imp.getCurrentSlice()-1]);
		imp.getRoi().setColor(new Color(0, 250, 50));
	}
	
	/**
	 * @return
	 */
	@SuppressWarnings("deprecation")
	private float summary() {
		
		int columnArea = rt.getColumnIndex("Area");
		float summarize = 0;
		for (int row = 0; row < rt.getCounter(); row++) {
			summarize += rt.getValue(columnArea, row);
		}
		if(showMore)
			IJ.log("Result of "+rt.getCounter()+" measures: "+summarize);
		return summarize;
	}
	
	private float calculate(JTextField tf_thickness) {
		float st = Float.parseFloat(tf_thickness.getText());
		float s = summary();
		float erg = (s * st) / 1000;
		return erg;
	}
	
	private float summary(ArrayList<Float> list) {
		float summarize = 0;
		for (Float f : list) {
			summarize += f;
		}
		return summarize;
	}

	/**
	 * Berechnung der Masse des Fettgewebes, 
	 * Dichte von Fett[0,94 kg/l] x Volumen
	 * @param fett 	-	Volumen des Fettes in ml
	 * @return Fettgewebsmasse in kg
	 */
	private String calculateMass(float fett){
		float masse = 0.94f * (fett/1000);
		return df_3.format(masse);
	}
	
	//Annotation darf nicht gelöscht werden, sonst verursacht ImageJ einen Absturz!
	@SuppressWarnings("deprecation")
	private void setSnakeROI(int x, int y){
		//TODO SnakeROI
		Wand wand = new Wand(imp.getProcessor());
		
		imp.killRoi();
		wand.npoints = 0;
		
		wand.autoOutline(x, y); 
		PolygonRoi roi_1 = new PolygonRoi(wand.xpoints, wand.ypoints, wand.npoints,
				imp, Roi.TRACED_ROI);	//POLYLINE);
		
		imp.setRoi(roi_1);
		roiArray_vat[imp.getCurrentSlice()-1] = imp.getRoi();
	}
	
	private void findSnakeLineColor() {
		setWaitCursor();
			fastSearched();
		setDefaultCursor();
	}

	/**
	 * @param isFound
	 */
	private void accurateSearched(boolean isFound) {
//		IJ.log("--- accurate search ---");
		for (int x = 0; x < imp.getWidth(); x+=20) {
			if(isFound)
				break;
			for (int y = 0; y < imp.getHeight(); y++) {
				if(imp.getPixel(x, y)[snakeColor_RED] == 255 && imp.getPixel(x, y)[1]==0 && imp.getPixel(x, y)[2]==0){
					isFound = true;
					if(showMore)
						IJ.log("Snake found: ("+x+","+y+")");
					setSnakeROI(x, y);
					break;
				}
			}
		}
		if(!isFound)
			IJ.log("Snake NOT found on slice " + imp.getCurrentSlice()+ "!");
	}

	private void fastSearched() {
		boolean isFound = false;
//		IJ.log("--- fast search ---");
		for (int i = 0; i < imp.getWidth(); i++) {
			if(imp.getPixel(i, i)[snakeColor_RED] == 255 && imp.getPixel(i, i)[1]==0 && imp.getPixel(i, i)[2]==0){
				isFound = true;
				if(showMore)
					IJ.log("Snake found: ("+i+","+i+")");
				setSnakeROI(i, i);
				break;
			}
		}
		if(!isFound){
			accurateSearched(isFound);
		}
	}
	
	/**
	 * 
	 */
	private void actionOfFindROI() {
		imp = WindowManager.getCurrentImage();
		imp_temp = WindowManager.getCurrentImage();
		int x = imp.getCurrentSlice() +1;
		if (x > imp.getStackSize()) {
			x = imp.getStackSize();
		}
		
		if(thresholdStack.size() < imp.getStackSize()){
			imp_temp.killRoi();
			
			thresholdStack.add(imp_temp.getProcessor().getAutoThreshold());
			if(showMore)
				IJ.log("slice "+imp_temp.getCurrentSlice()
						+" treshold: "+imp_temp.getProcessor().getAutoThreshold());
		}		
		
		if(imp.getCurrentSlice()==imp.getStackSize()){
			findSnakeLineColor();
			but_forward.setEnabled(true);
			but_back.setEnabled(true);
			cb_threshold.setEnabled(true);
			if(cb_threshold.isSelected())
				average(thresholdStack);
		}else{
			findSnakeLineColor();
			imp.setSlice(x);
		}
	}
	
	private int imageID;
	private void activate(JRadioButton rbut_visceral) {
		enableButtons(false);
		
		imp = null;
		imp_temp = null;
		if(rbut_visceral.isSelected()){
			imp = WindowManager.getCurrentImage();
			imageID = WindowManager.getIDList()[WindowManager.getIDList().length-1];
			imp_temp = imp;
			thresholdStack = new ArrayList<Integer>();
		}else{
			if(cb_threshold.isSelected()){
				cb_threshold.setEnabled(true);
			}else
				cb_threshold.setEnabled(false);
			IJ.log("Threshold:"+thresholdMin+" -- "+thresholdMax);
			WindowManager.getImage(WindowManager.getNthImageID(1)).getWindow().toFront();
			imp = WindowManager.getImage(imageID);
		}
		
		roiArray_vat = new Roi[imp.getStackSize()];
		rt = ResultsTable.getResultsTable();
		
		IJ.run(imp, "Enhance Contrast", "saturated=0");
		//*****************+
		IJ.run(imp, "8-bit", "");
		if(rbut_visceral.isSelected()){
			imp.getProcessor().setAutoThreshold(ImageProcessor.ISODATA2, ImageProcessor.NO_LUT_UPDATE);
		}else{
			if(cb_threshold.isSelected()){
				thresholdMin = thresholdAverage;
			}
			imp.getProcessor().setThreshold(thresholdMin, thresholdMax, ImageProcessor.NO_LUT_UPDATE);
		}
		
		thresholdMin = imp.getProcessor().getMinThreshold();
		thresholdMax = imp.getProcessor().getMaxThreshold();
		//******************
		imp.killRoi();
		
		//activate all buttons
		but_calculate.setEnabled(true);
		cb_snake.setEnabled(true);
	}
	
	private void runSnake() {
		if(rm!=null && rm.isShowing())
			killRoiManager(); 
		IJ.run(imp, "ABSnake", "");
		rm = RoiManager.getInstance();
//		rm.addRoi(imp.getRoi());
		but_findROI.setEnabled(true);
	}
	
	/**
	 * @param tf_compl
	 * @param tf_visc
	 * @param tf_result
	 */
	private void difference(final JTextField tf_compl,
			final JTextField tf_visc, final JTextField tf_result, final JLabel quotient) {
		float visc = Float.parseFloat(tf_visc.getText().replace(",", "."));
		float res = Float.parseFloat(tf_compl.getText().replace(",", ".")) - visc;
		
		for (int i = 0; i < tModel_vat.getRowCount(); i++) {
			scat[0] = String.valueOf(i+1);
			float tat_f1 = Float.parseFloat(tModel_tat.getValueAt(i, 1).toString().replace(",", "."));
			float vat_f1 = Float.parseFloat(tModel_vat.getValueAt(i, 1).toString().replace(",", "."));
			float tat_f2 = Float.parseFloat(tModel_tat.getValueAt(i, 2).toString().replace(",", "."));
			float vat_f2 = Float.parseFloat(tModel_vat.getValueAt(i, 2).toString().replace(",", "."));
			scat[1] = df_1.format(tat_f1 - vat_f1); 
			scat[2] = df_3.format(tat_f2 - vat_f2);	
			if(tModel_scat.getRowCount() < imp.getStackSize()){
				tModel_scat.addRow(scat);
			}	
 		} 
			
		tf_scat_mass.setText(calculateMass(res)); 
		ratio(tf_result, quotient, visc, res);
		playSound();
		roiArray_vat = null;
	}

	/**
	 * @param result
	 * @param quotient
	 * @param visc
	 * @param res
	 */
	private void ratio(final JTextField result, final JLabel quotient,
			float visc, float res) {
		float e = 0;
		String s = "";
		result.setText(String.valueOf(df_1.format(res)));
		if(visc < res){
			e = res/visc;
			s = "1 : ".concat(String.valueOf(df_1.format(e)));
		}else{
			e = visc/res;
			s = String.valueOf(df_1.format(e)).concat(" : 1 ");
		}
		quotient.setText(s);
	}
	
	private void reset() {
		// TODO Reset
		tf_thickness.setText("01.0");
		tf_particleMin.setText("9");
		tf_particleMax.setText("Infinity");
		
		for (int i = tModel_vat.getRowCount()-1; i >= 0; i--) {
			tModel_vat.removeRow(i);
		}
		for (int i = tModel_tat.getRowCount()-1; i >= 0; i--) {
			tModel_tat.removeRow(i);
		}
		for (int i = tModel_scat.getRowCount()-1; i >= 0; i--) {
			tModel_scat.removeRow(i);
		}
		resultTable_vat.updateUI();
		resultTable_tat.updateUI();
		resultTable_scat.updateUI();
		
		enableButtons(false);
		
		imp.killRoi(); imp.killStack();
		killRoiManager();
	}
	
	private void killRoiManager(){
		rm.close();
	}
	
	private void enableButtons(boolean b){
		but_forward.setEnabled(b);
		but_back.setEnabled(b);
		
		cb_snake.setSelected(b);
	}
	
	private void playSound() {
		if(IJ.isWindows()){
			try{
				File f = new File( "C:/Windows/Media/tada.wav" ); 
	            AudioInputStream audioInputStream = AudioSystem.getAudioInputStream(f);
	            AudioFormat af = audioInputStream.getFormat();
	            int size = (int) (af.getFrameSize() * audioInputStream.getFrameLength());
	            byte[] audio = new byte[size];
	            DataLine.Info info = new DataLine.Info(Clip.class, af, size);
	            audioInputStream.read(audio, 0, size);
	            
                Clip clip = (Clip) AudioSystem.getLine(info);
                clip.open(af, audio, 0, size);
                clip.start();
                
	            audioInputStream.close();
	        }catch(Exception e){ e.printStackTrace(); }
	        
		}

	}
	
	private void setWaitCursor() {
		Cursor hourglassCursor = new Cursor(Cursor.WAIT_CURSOR);
		setCursor(hourglassCursor);
	}

	private void setDefaultCursor() {
		Cursor normalCursor = new Cursor(Cursor.DEFAULT_CURSOR);
		setCursor(normalCursor);
	}
	
	
	/**
     * Abstract the previous / next slice functionality.
     */
	private class SliceMover implements ActionListener {	
		private int n;

		public SliceMover(int n) {
			this.n = n;
		}

		public void actionPerformed(ActionEvent e) {
			if(e.getActionCommand()=="forward" || e.getActionCommand()=="back"){
				int x = imp.getCurrentSlice() + n;
				if (x > imp.getStackSize()) {
					x = imp.getStackSize();
				} else if (x < 1) {
					x = 1;
				}
	
				imp.setSlice(x);
				setSavedROI(); 
			}
			
		}

	}
	
	private class MessageFrame extends JFrame{
		
		/**
		 * 
		 */
		private static final long serialVersionUID = 5718763819555296586L;
		JPanel absolutePan = new JPanel();
		
		public MessageFrame(){
			this.setUndecorated(true);
			getContentPane().add(absolutePan, BorderLayout.CENTER);
			absolutePan.setBorder(new LineBorder(new java.awt.Color(0,0,0), 2, true));
			absolutePan.setLayout(null);
			{
				JLabel l_head = new JLabel();
				absolutePan.add(l_head);
				l_head.setText("AATAP v.1.1");
				l_head.setBounds(167, 11, 96, 21);
				l_head.setFont(new java.awt.Font("Arial",1,14));
			}
			{
				JLabel l_beschreibg = new JLabel();
				absolutePan.add(l_beschreibg);
				l_beschreibg.setText("by");
				l_beschreibg.setBounds(12, 44, 60, 20);
			}
			{
				JLabel l_beschrText = new JLabel();
				absolutePan.add(l_beschrText);
				l_beschrText.setText("Daniel Kruber & Matthias Raschpichler");
				l_beschrText.setBounds(24, 62, 220, 20);
			}
			{
				JTextArea ta_beschr = new JTextArea();
				ta_beschr.setEditable(false);
				absolutePan.add(ta_beschr);
				ta_beschr.setText(msg_help);
				ta_beschr.setBounds(12, 84, 387, 210);
			}
			pack();
			
		}
	}
	
	private class Msg4SnakeParameters extends JFrame{
		
		/**
		 * 
		 */
		private static final long serialVersionUID = 1642214203649072852L;
		JPanel absolutePan = new JPanel();
		
		public Msg4SnakeParameters() {
			init();
		}
		
		private void init(){
			try {
				setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
				getContentPane().add(absolutePan, BorderLayout.CENTER);
				absolutePan.setLayout(null);
				absolutePan.setBorder(new LineBorder(new java.awt.Color(0,0,0), 2, true));
				{
					JLabel l_head = new JLabel();
					absolutePan.add(l_head);
					l_head.setText("recommended Snake-parameter");
					l_head.setBounds(12, 11, 231, 21);
					l_head.setFont(new java.awt.Font("Arial",1,14));
				}
				{
					JLabel l_beschreibg = new JLabel();
					absolutePan.add(l_beschreibg);
					l_beschreibg.setText("Gradient threshold:");
					l_beschreibg.setBounds(26, 44, 140, 18);
					l_beschreibg.setFont(new java.awt.Font("Segoe UI",0,12));
				}
				{
					JLabel l_gtvalue = new JLabel();
					absolutePan.add(l_gtvalue);
					l_gtvalue.setText("50");
					l_gtvalue.setBounds(178, 45, 32, 16);
					l_gtvalue.setFont(new java.awt.Font("Segoe UI",1,12));
				}
				{
					JLabel l_noi = new JLabel();
					absolutePan.add(l_noi);
					l_noi.setText("Number of iterations:");
					l_noi.setBounds(26, 62, 140, 16);
					l_noi.setFont(new java.awt.Font("Segoe UI",0,12));
				}
				{
					JLabel l_noivalue = new JLabel();
					absolutePan.add(l_noivalue);
					l_noivalue.setText("30");
					l_noivalue.setBounds(178, 62, 32, 16);
					l_noivalue.setFont(new java.awt.Font("Segoe UI",1,12));
				}
				{
					JLabel l_dc = new JLabel();
					absolutePan.add(l_dc);
					l_dc.setText("Draw color:");
					l_dc.setBounds(26, 78, 117, 16);
					l_dc.setFont(new java.awt.Font("Segoe UI",0,12));
				}
				{
					JLabel l_dcvalue = new JLabel();
					absolutePan.add(l_dcvalue);
					l_dcvalue.setText("Red");
					l_dcvalue.setBounds(178, 78, 47, 16);
					l_dcvalue.setFont(new java.awt.Font("Segoe UI",1,12));
				}
				{
					JLabel l_notice = new JLabel();
					absolutePan.add(l_notice);
					l_notice.setText("'Advanced options'");
					l_notice.setBounds(19, 111, 124, 16);
					l_notice.setFont(new java.awt.Font("Segoe UI",1,12));
				}
				{
					JLabel l_notice_2 = new JLabel();
					absolutePan.add(l_notice_2);
					l_notice_2.setText("enable --> OK");
					l_notice_2.setBounds(131, 111, 122, 16);
					l_notice_2.setFont(new java.awt.Font("Segoe UI",0,12));
				}
				{
					JLabel l_disMin = new JLabel();
					absolutePan.add(l_disMin);
					l_disMin.setText("Displacement min:");
					l_disMin.setBounds(26, 133, 117, 16);
					l_disMin.setFont(new java.awt.Font("Segoe UI",0,12));
				}
				{
					JLabel l_disMinValue = new JLabel();
					absolutePan.add(l_disMinValue);
					l_disMinValue.setText("0");
					l_disMinValue.setBounds(178, 133, 32, 16);
					l_disMinValue.setFont(new java.awt.Font("Segoe UI",1,12));
				}
				{
					JLabel l_disMax = new JLabel();
					absolutePan.add(l_disMax);
					l_disMax.setText("Displacement max:");
					l_disMax.setBounds(26, 149, 117, 16);
					l_disMax.setFont(new java.awt.Font("Segoe UI",0,12));
				}
				{
					JLabel l_disMaxValue = new JLabel();
					absolutePan.add(l_disMaxValue);
					l_disMaxValue.setText("0.2");
					l_disMaxValue.setBounds(178, 149, 32, 16);
					l_disMaxValue.setFont(new java.awt.Font("Segoe UI",1,12));
				}
				{
					JLabel l_iaMin = new JLabel();
					absolutePan.add(l_iaMin);
					l_iaMin.setText("inv alpha min:");
					l_iaMin.setBounds(26, 165, 117, 16);
					l_iaMin.setFont(new java.awt.Font("Segoe UI",0,12));
				}
				{
					JLabel l_iaMinValue = new JLabel();
					absolutePan.add(l_iaMinValue);
					l_iaMinValue.setText("0");
					l_iaMinValue.setBounds(178, 165, 32, 16);
					l_iaMinValue.setFont(new java.awt.Font("Segoe UI",1,12));
				}
				{
					JLabel l_iaMax = new JLabel();
					absolutePan.add(l_iaMax);
					l_iaMax.setText("inv alpha max:");
					l_iaMax.setBounds(26, 181, 117, 16);
					l_iaMax.setFont(new java.awt.Font("Segoe UI",0,12));
				}
				{
					JLabel l_iaMaxValue = new JLabel();
					absolutePan.add(l_iaMaxValue);
					l_iaMaxValue.setText("0.5");
					l_iaMaxValue.setBounds(178, 181, 32, 16);
					l_iaMaxValue.setFont(new java.awt.Font("Segoe UI",1,12));
				}
				{
					JLabel l_ok = new JLabel();
					absolutePan.add(l_ok);
					l_ok.setText("--> OK");
					l_ok.setBounds(183, 203, 60, 16);
					l_ok.setFont(new java.awt.Font("Segoe UI",0,12));
				}
				pack();
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}
	
	public class ExportAdapter implements ActionListener {
		private String rowstring, value;
		private Clipboard system;
		private StringSelection stsel;
		private JTable jTable1;

		/**
		 * The Excel Adapter is constructed with a JTable on which it enables
		 * Copy-Paste and acts as a Clipboard listener.
		 */
		public ExportAdapter(JTable myJTable) {
			jTable1 = myJTable;
			KeyStroke copy = KeyStroke.getKeyStroke(KeyEvent.VK_C,
					ActionEvent.CTRL_MASK, false);
			KeyStroke paste = KeyStroke.getKeyStroke(KeyEvent.VK_V,
					ActionEvent.CTRL_MASK, false);
			jTable1.registerKeyboardAction(this, "Copy", copy,
					JComponent.WHEN_FOCUSED);
			jTable1.registerKeyboardAction(this, "Paste", paste,
					JComponent.WHEN_FOCUSED);
			system = Toolkit.getDefaultToolkit().getSystemClipboard();
		}

		/**
		 * This method is activated on the Keystrokes we are listening to in this
		 * implementation. Here it listens for Copy and Paste ActionCommands.
		 * Selections comprising non-adjacent cells result in invalid selection and
		 * then copy action cannot be performed. Paste is done by aligning the upper
		 * left corner of the selection with the 1st element in the current
		 * selection of the JTable.
		 */
		public void actionPerformed(ActionEvent e) {
			
			if (e.getActionCommand().compareTo("Copy") == 0){
	            StringBuffer sbf = new StringBuffer();
	            int numcols = jTable1.getSelectedColumnCount();
	            int numrows = jTable1.getSelectedRowCount();
	            int[] rowsselected = jTable1.getSelectedRows();
	            int[] colsselected = jTable1.getSelectedColumns();
	            if (!((numrows - 1 == rowsselected[rowsselected.length - 1] - rowsselected[0]
	                    && numrows == rowsselected.length)
	                    && (numcols - 1 == colsselected[colsselected.length - 1] - colsselected[0]
	                    && numcols == colsselected.length)))
	            {
	                JOptionPane.showMessageDialog(null, "Invalid Copy Selection",
	                        "Invalid Copy Selection",
	                        JOptionPane.ERROR_MESSAGE);

	                return;
	            }

	            for (int i = 0; i < numrows; i++){
	                for (int j = 0; j < numcols; j++){
	                    sbf.append(jTable1.getValueAt(rowsselected[i], colsselected[j]));
	                    if (j < numcols - 1){
	                        sbf.append("\t");
	                    }
	                }
	                sbf.append("\n");
	            }
	            stsel = new StringSelection(sbf.toString());
	            system = Toolkit.getDefaultToolkit().getSystemClipboard();
	            system.setContents(stsel, stsel);
	        }


			if (e.getActionCommand().compareTo("Paste") == 0) {
				int startRow = (jTable1.getSelectedRows())[0];
				int startCol = (jTable1.getSelectedColumns())[0];
				try {
					String trstring = (String) (system.getContents(this)
							.getTransferData(DataFlavor.stringFlavor));
					StringTokenizer st1 = new StringTokenizer(trstring, "\n");
					for (int i = 0; st1.hasMoreTokens(); i++) {
						rowstring = st1.nextToken();
						StringTokenizer st2 = new StringTokenizer(rowstring, "\t",
								true);

						String oldValue = "";
						int col = 0;
						for (int j = 0; st2.hasMoreTokens(); j++) {
							value = (String) st2.nextToken();
							if (value.equals("\t")) {

								if (oldValue.equals("\t")) {
									value = "";

									if (startRow + i < jTable1.getRowCount()
											&& startCol + col < jTable1
													.getColumnCount()) {
										jTable1.setValueAt(value, startRow + i,
												startCol + col);
										col++;
									}
								}
								oldValue = "\t";

							} else {
								oldValue = value;
								if (startRow + i < jTable1.getRowCount()
										&& startCol + col < jTable1
												.getColumnCount()) {
									jTable1.setValueAt(value, startRow + i,
											startCol + col);
									col++;
								}
							}
						}
					}
				} catch (Exception ex) {
					ex.printStackTrace();
				}
			}
		}
	}

}
